/*****************************************
 * Large Assignment 1: L-System Lace
 * Name:    Ben Liu
 * E-mail:  bliu1013@unm.edu
 * Course:      CS491, Computational Fabrication
 * Submitted:    2/10/2022
 *
 * This program generates 4 different L-systems. 
 * Select them using the number keys below:
 * 1) An abstract fractal
 * 2) A botanical form
 * 3) An L-System using non-lines
 * 4) A Rogan Brown inspired system
***********************************************/
import Turtle.*;
import java.util.*;
import processing.pdf.*;

Turtle t;

void setup() {
  size(800, 800);
  background(#08E4FF);
  t = new Turtle(this);
}

void draw() {
  
}

void keyPressed() {
  if (key == 's') {
    println("Saving...");
    save("Image-" + second() + ".jpg");
  }
  
  //Reset the picture every time
  background(#08E4FF);
  resetTurtle();
  strokeWeight(1.2);

  if (key == '1') {
    beginRecord(PDF, "Fractal.pdf");
    println("Drawing Fractal");
    drawFractal(10, 45);
    endRecord();
  }
  else if (key == '2') {
    beginRecord(PDF, "Tree.pdf");
    println("Drawing Tree");
    drawTree(6, 12, 3);
    endRecord();
  }
  else if (key == '3') {
    beginRecord(PDF, "Nonlinear.pdf");
    println("Drawing Nonlinear");
    nonLinear(20, 30, 3);
    endRecord();
  }
  else if (key == '4') {
    beginRecord(PDF, "RG-Like.pdf");
    println("Drawing Rogan Brownian");
    for (int i=60; i<=70; i+=2) {
      roganBrown(i);
    }
    endRecord();
  }
}

//Puts the turtle back at the center of the screen
void resetTurtle() {
  t.penUp();
  t.goToPoint(width/2, height/2);
  t.setHeading(0);
  t.penDown();
}
