void nonLinear(float len, float angle, int iters) {
  String[][] rules = {{"F", "FF"},
                      {"X", "F+[[FX]+F]-F[+FX]-X", "F-[[FX]-F]+F[+[FX]-FX]", "F-FX+[-F[-F[+[FX]+FX]]]"},
                      {"[", "["}, 
                      {"]", "]"}, 
                      {"+", "+"}, 
                      {"-", "-"}};
                      
  String axiom = "X";
  String computedWord = axiom;
  Stack<TurtlePos> stack = new Stack<>();
  
  //Put the turtle at the bottom
  t.setY(height);
  
  //Compute the new word
  for (int i=0; i<iters; i++) {
    String tempWord = computedWord;
    computedWord = "";
    
    for (int j=0; j<tempWord.length(); j++) {
      char c = tempWord.charAt(j);
      
      for (String[] r : rules) {
        if (c == r[0].charAt(0) && c == 'X') {
           computedWord += r[(int)random(1,3)];
        }
        else if (c == r[0].charAt(0)) {
          computedWord += r[1];  
        }
      }
    }
  }
  
  //Draw the string, brackets are based on ABOP page 24
  for (char c : computedWord.toCharArray()) {
    if (c == 'F') {
      //Draw a diamond
      t.left(30);
      t.forward(len);
      t.right(60);
      t.forward(len);
      t.right(120);
      t.forward(len);
      t.right(60);
      t.forward(len);
      t.right(150);
      
      //Lift the pen and go through the diamond
      t.penUp();
      t.forward(sqrt(3)*len);
      t.penDown();
      
      fill(0);
    }
    else if (c == '[') {
      stack.push(new TurtlePos(t.getX(), t.getY(), t.getHeading()));
    }
    else if (c == ']') {
      TurtlePos position = stack.pop();
      t.setX(position.getX());
      t.setY(position.getY());
      t.setHeading(position.getHeading());
    }
    else if (c == '+') {
      t.right(angle);  
    }
    else if (c == '-') {
      t.left(angle);  
    }
  }
}
