void roganBrown(float len) {
  strokeWeight(2);
  for (int i=0; i<4; i++) {
    resetTurtle();
    t.setHeading(90 * i);
    generate(len);
  }
}


void generate(float len) {
  String[][] rules = {{"F", "F"},
                      {"X", "F[+FX][-FX]", "F[-FX[+X][-X]][+FX[-X][+X]]", "F[-FX[-X][-X]][+FX[+X][+X]]"},
                      {"[", "["}, 
                      {"]", "]"}, 
                      {"+", "+"}, 
                      {"-", "-"}};
                      
  String axiom = "X";
  String computedWord = axiom;
  Stack<TurtlePos> stack = new Stack<>();
  
  
  
  //Compute the new word
  for (int i=0; i<2; i++) {
    String tempWord = computedWord;
    computedWord = "";
    
    for (int j=0; j<tempWord.length(); j++) {
      char c = tempWord.charAt(j);
      
      for (String[] r : rules) {
        if (c == r[0].charAt(0) && c == 'X') {
           computedWord += r[(int)random(1,3)];
        }
        else if (c == r[0].charAt(0)) {
          computedWord += r[1];  
        }
      }
    }
  }
  
  //Draw the string, brackets are based on ABOP page 24
  for (char c : computedWord.toCharArray()) {
    //Move the turtle in a curve
    if (c == 'F') {
      int curve = int(random(2));
      float heading = t.getHeading();
  
      for (int i=0; i<len;i++) {
        t.forward(1);
        if (curve == 0 && i < len/2) {
          t.right(1);
        }
        else if (curve == 0) {
          t.left(1);  
        }
        if (curve == 1 && i < len/2) {
          t.left(1);
        }
        else if (curve == 1) {
          t.right(1);  
        }
      }
      
      //Set the turtle back to its original heading
      t.setHeading(heading);
    }
    else if (c == '[') {
      stack.push(new TurtlePos(t.getX(), t.getY(), t.getHeading()));
    }
    else if (c == ']') {
      TurtlePos position = stack.pop();
      t.setX(position.getX());
      t.setY(position.getY());
      t.setHeading(position.getHeading());
    }
    else if (c == '+') {
      t.right(random(12, 30));  
    }
    else if (c == '-') {
      t.left(random(12, 30));  
    }
  }
}
